ALTER TABLE BLACK_ACTION DROP CONSTRAINT FK_BLACK_ACTION_BLACK_LIST
;

ALTER TABLE BLACK_ACTION DROP CONSTRAINT FK_BLACK_ACTION_LOOKUP
;

ALTER TABLE BLACK_LIST DROP CONSTRAINT FK_BLACK_LIST_LB_USER
;

ALTER TABLE BOOK DROP CONSTRAINT FK_BOOK_AUTHOR
;

ALTER TABLE BOOK DROP CONSTRAINT FK_BOOK_PUBLISHER
;

ALTER TABLE BOOK DROP CONSTRAINT FK_BOOK_GENRE
;

ALTER TABLE COLLECTION DROP CONSTRAINT FK_COLLECTION_BOOK
;

ALTER TABLE COLLECTION DROP CONSTRAINT FK_COLLECTION_LIBRARY
;

ALTER TABLE COLLECTION_STATUS DROP CONSTRAINT FK_COLLECTION_STATUS_COLLECTION
;

ALTER TABLE COLLECTION_STATUS DROP CONSTRAINT FK_COLLECTION_STATUS_LOOKUP
;

ALTER TABLE GENRE DROP CONSTRAINT FK_GENRE_GENRE
;

ALTER TABLE LB_USER DROP CONSTRAINT FK_LB_USER_LIBRARY
;

ALTER TABLE LENDING DROP CONSTRAINT FK_LENDING_LIBRARY
;

ALTER TABLE LENDING DROP CONSTRAINT FK_LENDING_LB_USER
;

ALTER TABLE LENDING_COLLECTION DROP CONSTRAINT FK_LENDING_COLLECTION_LENDING
;

ALTER TABLE LENDING_COLLECTION DROP CONSTRAINT FK_LENDING_COLLECTION_COL
;

ALTER TABLE NEXT_LIBRARY DROP CONSTRAINT FK_NEXT_LIBRARY_LIBRARY_ID
;

ALTER TABLE NEXT_LIBRARY DROP CONSTRAINT FK_NEXT_LIBRARY_NEXT_LIBRARY_ID
;


DROP TABLE AUTHOR
;
DROP TABLE BLACK_ACTION
;
DROP TABLE BLACK_ACTION_LOOKUP
;
DROP TABLE BLACK_LIST
;
DROP TABLE BOOK
;
DROP TABLE COLLECTION
;
DROP TABLE COLLECTION_STATUS
;
DROP TABLE COLLECTION_STATUS_LOOKUP
;
DROP TABLE GARBAGE
;
DROP TABLE GENRE
;
DROP TABLE LB_USER
;
DROP TABLE LENDING
;
DROP TABLE LENDING_COLLECTION
;
DROP TABLE LIBRARY
;
DROP TABLE NEXT_LIBRARY
;
DROP TABLE PUBLISHER
;

CREATE TABLE AUTHOR ( 
	AUTHOR_ID integer NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	AUTHOR_NAME varchar(80) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE BLACK_ACTION ( 
	BLACK_ACTION_ID integer NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	BLACK_LIST_ID integer NOT NULL,
	BLACK_ACTION_CODE char(3) NOT NULL,
	BLACK_LEVEL smallint NOT NULL,
	EVIDENCE_PHOTOGRAPH blob,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE BLACK_ACTION_LOOKUP ( 
	BLACK_ACTION_CODE char(3) NOT NULL,
	BLACK_ACTION_NAME varchar(80) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE BLACK_LIST ( 
	BLACK_LIST_ID integer NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	LB_USER_ID integer NOT NULL,
	BLACK_RANK char(3) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE BOOK ( 
	BOOK_ID integer NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	ISBN_NO varchar(20) NOT NULL,
	BOOK_NAME varchar(80) NOT NULL,
	AUTHOR_ID integer NOT NULL,
	PUBLISHER_ID integer NOT NULL,
	MAX_LENDING_DATE_COUNT smallint NOT NULL,
	GENRE_CODE varchar(12),
	OPENING_PART clob,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE COLLECTION ( 
	COLLECTION_ID integer NOT NULL,
	LIBRARY_ID smallint NOT NULL,
	BOOK_ID integer NOT NULL,
	ARRIVAL_DATE timestamp NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE COLLECTION_STATUS ( 
	COLLECTION_ID integer NOT NULL,
	COLLECTION_STATUS_CODE char(3) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE COLLECTION_STATUS_LOOKUP ( 
	COLLECTION_STATUS_CODE char(3) NOT NULL,
	COLLECTION_STATUS_NAME varchar(80) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE GARBAGE ( 
	GARBAGE_MEMO varchar(50),
	GARBAGE_TIME timestamp
)
;

CREATE TABLE GENRE ( 
	GENRE_CODE varchar(12) NOT NULL,
	GENRE_NAME varchar(80) NOT NULL,
	PARENT_GENRE_CODE varchar(12),
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE LB_USER ( 
	LB_USER_ID integer NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	LB_USER_NAME varchar(80) NOT NULL,
	LIBRARY_ID smallint NOT NULL,
	USER_PASSWORD varchar(50) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE LENDING ( 
	LENDING_ID integer NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	LIBRARY_ID smallint NOT NULL,
	LB_USER_ID integer NOT NULL,
	LENDING_DATE timestamp NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE LENDING_COLLECTION ( 
	LENDING_ID integer NOT NULL,
	COLLECTION_ID integer NOT NULL,
	RETURN_LIMIT_DATE timestamp NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE LIBRARY ( 
	LIBRARY_ID smallint NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	LIBRARY_NAME varchar(80) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE NEXT_LIBRARY ( 
	LIBRARY_ID smallint NOT NULL,
	NEXT_LIBRARY_ID smallint NOT NULL,
	DISTANCE_KM integer NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;

CREATE TABLE PUBLISHER ( 
	PUBLISHER_ID integer NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1),
	PUBLISHER_NAME varchar(80) NOT NULL,
	R_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	U_TIME timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
	R_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL,
	U_STAFF varchar(50) DEFAULT 'DefaultStaff' NOT NULL
)
;


ALTER TABLE AUTHOR ADD CONSTRAINT PK_AUTHOR 
	PRIMARY KEY (AUTHOR_ID)
;

ALTER TABLE BLACK_ACTION ADD CONSTRAINT PK_BLACK_ACTION 
	PRIMARY KEY (BLACK_ACTION_ID)
;

ALTER TABLE BLACK_ACTION_LOOKUP ADD CONSTRAINT PK_BLACK_ACTION_LOOKUP 
	PRIMARY KEY (BLACK_ACTION_CODE)
;

ALTER TABLE BLACK_LIST ADD CONSTRAINT PK_BLACK_LIST 
	PRIMARY KEY (BLACK_LIST_ID)
;

ALTER TABLE BOOK ADD CONSTRAINT PK_BOOK 
	PRIMARY KEY (BOOK_ID)
;

ALTER TABLE COLLECTION ADD CONSTRAINT PK_COLLECTION 
	PRIMARY KEY (COLLECTION_ID)
;

ALTER TABLE COLLECTION_STATUS ADD CONSTRAINT PK_COLLECTION_STATUS 
	PRIMARY KEY (COLLECTION_ID)
;

ALTER TABLE COLLECTION_STATUS_LOOKUP ADD CONSTRAINT PK_COLLECTION_STATUS_LOOKUP 
	PRIMARY KEY (COLLECTION_STATUS_CODE)
;

ALTER TABLE GENRE ADD CONSTRAINT PK_GENRE 
	PRIMARY KEY (GENRE_CODE)
;

ALTER TABLE LB_USER ADD CONSTRAINT PK_LB_USER 
	PRIMARY KEY (LB_USER_ID)
;

ALTER TABLE LENDING ADD CONSTRAINT PK_LENDING 
	PRIMARY KEY (LENDING_ID)
;

ALTER TABLE LENDING_COLLECTION ADD CONSTRAINT PK_LENDING_COLLECTION 
	PRIMARY KEY (LENDING_ID, COLLECTION_ID)
;

ALTER TABLE LIBRARY ADD CONSTRAINT PK_LIBRARY 
	PRIMARY KEY (LIBRARY_ID)
;

ALTER TABLE NEXT_LIBRARY ADD CONSTRAINT PK_NEXT_LIBRARY 
	PRIMARY KEY (LIBRARY_ID, NEXT_LIBRARY_ID)
;

ALTER TABLE PUBLISHER ADD CONSTRAINT PK_PUBLISHER 
	PRIMARY KEY (PUBLISHER_ID)
;


ALTER TABLE BOOK
	ADD CONSTRAINT UQ_BOOK_ISBN_NO UNIQUE (ISBN_NO)
;

ALTER TABLE COLLECTION
	ADD CONSTRAINT UQ_COLLECTION_Primary UNIQUE (LIBRARY_ID, BOOK_ID)
;

ALTER TABLE LENDING
	ADD CONSTRAINT UQ_LENDING_Primary UNIQUE (LIBRARY_ID, LB_USER_ID)
;

ALTER TABLE BLACK_LIST
	ADD CONSTRAINT UQ_BLACK_LIST_LB_USER_ID UNIQUE (LB_USER_ID)
;

ALTER TABLE LIBRARY
	ADD CONSTRAINT UQ_LIBRARY_LIBRARY_NAME UNIQUE (LIBRARY_NAME)
;



ALTER TABLE BLACK_ACTION ADD CONSTRAINT FK_BLACK_ACTION_BLACK_LIST 
	FOREIGN KEY (BLACK_LIST_ID) REFERENCES BLACK_LIST (BLACK_LIST_ID)
;

ALTER TABLE BLACK_ACTION ADD CONSTRAINT FK_BLACK_ACTION_LOOKUP 
	FOREIGN KEY (BLACK_ACTION_CODE) REFERENCES BLACK_ACTION_LOOKUP (BLACK_ACTION_CODE)
;

ALTER TABLE BLACK_LIST ADD CONSTRAINT FK_BLACK_LIST_LB_USER 
	FOREIGN KEY (LB_USER_ID) REFERENCES LB_USER (LB_USER_ID)
;

ALTER TABLE BOOK ADD CONSTRAINT FK_BOOK_AUTHOR 
	FOREIGN KEY (AUTHOR_ID) REFERENCES AUTHOR (AUTHOR_ID)
;

ALTER TABLE BOOK ADD CONSTRAINT FK_BOOK_PUBLISHER 
	FOREIGN KEY (PUBLISHER_ID) REFERENCES PUBLISHER (PUBLISHER_ID)
;

ALTER TABLE BOOK ADD CONSTRAINT FK_BOOK_GENRE 
	FOREIGN KEY (GENRE_CODE) REFERENCES GENRE (GENRE_CODE)
;

ALTER TABLE COLLECTION ADD CONSTRAINT FK_COLLECTION_BOOK 
	FOREIGN KEY (BOOK_ID) REFERENCES BOOK (BOOK_ID)
;

ALTER TABLE COLLECTION ADD CONSTRAINT FK_COLLECTION_LIBRARY 
	FOREIGN KEY (LIBRARY_ID) REFERENCES LIBRARY (LIBRARY_ID)
;

ALTER TABLE COLLECTION_STATUS ADD CONSTRAINT FK_COLLECTION_STATUS_COLLECTION 
	FOREIGN KEY (COLLECTION_ID) REFERENCES COLLECTION (COLLECTION_ID)
;

ALTER TABLE COLLECTION_STATUS ADD CONSTRAINT FK_COLLECTION_STATUS_LOOKUP 
	FOREIGN KEY (COLLECTION_STATUS_CODE) REFERENCES COLLECTION_STATUS_LOOKUP (COLLECTION_STATUS_CODE)
;

ALTER TABLE GENRE ADD CONSTRAINT FK_GENRE_GENRE 
	FOREIGN KEY (PARENT_GENRE_CODE) REFERENCES GENRE (GENRE_CODE)
;

ALTER TABLE LB_USER ADD CONSTRAINT FK_LB_USER_LIBRARY 
	FOREIGN KEY (LIBRARY_ID) REFERENCES LIBRARY (LIBRARY_ID)
;

ALTER TABLE LENDING ADD CONSTRAINT FK_LENDING_LIBRARY 
	FOREIGN KEY (LIBRARY_ID) REFERENCES LIBRARY (LIBRARY_ID)
;

ALTER TABLE LENDING ADD CONSTRAINT FK_LENDING_LB_USER 
	FOREIGN KEY (LB_USER_ID) REFERENCES LB_USER (LB_USER_ID)
;

ALTER TABLE LENDING_COLLECTION ADD CONSTRAINT FK_LENDING_COLLECTION_LENDING 
	FOREIGN KEY (LENDING_ID) REFERENCES LENDING (LENDING_ID)
;

ALTER TABLE LENDING_COLLECTION ADD CONSTRAINT FK_LENDING_COLLECTION_COL 
	FOREIGN KEY (COLLECTION_ID) REFERENCES COLLECTION (COLLECTION_ID)
;

ALTER TABLE NEXT_LIBRARY ADD CONSTRAINT FK_NEXT_LIBRARY_LIBRARY_ID 
	FOREIGN KEY (LIBRARY_ID) REFERENCES LIBRARY (LIBRARY_ID)
;

ALTER TABLE NEXT_LIBRARY ADD CONSTRAINT FK_NEXT_LIBRARY_NEXT_LIBRARY_ID 
	FOREIGN KEY (NEXT_LIBRARY_ID) REFERENCES LIBRARY (LIBRARY_ID)
;
